#ifndef SCANNERSAUX_H
#define SCANNERSAUX_H
#include <cstddef>
#include <vector>
#include <cmath>
#include <cstdlib>

#include <gsl/gsl_vector.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_integration.h>

#include "ScannerSModelclasses.h"

int GaussUpTriang(std::vector< std::vector<double> > & M);
void GaussSolveUpTriang(std::vector< std::vector<double> > & M,unsigned int & NIC,std::vector<unsigned int> & order, int hcont);
void RedBydV(std::vector<std::vector<double> > & dV,deriv2V & d2V, unsigned int NIC, std::vector<unsigned int>  & orderdV);
void GenMrot(double * Mdata, int dim, RandGen & r);


void FindAprioriEigenDirs(deriv2V & d2V,std::vector< std::vector<double> > & Mbasis,double * Agen,double * Bgen,double * TempOut,std::vector<unsigned int>  & orderdV, std::vector<int> & degen,std::vector<int> & BlockInfo,std::vector<unsigned int> & BlockDims, unsigned int & kflat,unsigned int & kcurved,unsigned int NIC,RandGen & r);
void ConvertEigen(deriv2V & d2V,deriv2V & d2Vnew,std::vector< std::vector<double> > & Mbasis,std::vector<unsigned int>  & orderdV,unsigned int kflat,unsigned int kcurved,unsigned int NIC);
void GenerateMrot(deriv2V & d2Vnew,std::vector< std::vector<double> > & Mrot,std::vector<unsigned int>  & orderdV,unsigned int kminus2,unsigned int NIC,RandGen & r);
void ConvertWithMrot(deriv2V & d2Vnew,std::vector< std::vector<double> > & Mrot,std::vector<unsigned int>  & orderdV,unsigned int kminus2,unsigned int NIC,RandGen & r);


void PrintNflatCandidates(deriv2V & d2V,double * TempM,double * TempOut,std::vector<unsigned int>  & orderdV,unsigned int NIC);

void EigenSystemRsym(int N,double * DataIn, double * DataOut);
void EigenSystemRsymNoSort(int N,double * DataIn, double * DataOut);

double factorial(double n);
double Integrator(double A, double (*Integrand)(double, void *));
double Interp(double x, double * table);

#endif
