#include"ScannerSEWPO.h"

double Fsimple(double A){
  return A*(3*log(A)/(1e0-A)-0.5)/4e0;
}

double PsiTot(double A){
  return Integrator(A,PsiIntegrand)-A*log(A)/4e0-Fsimple(A);
}

double PsiIntegrand(double x,void * params){
  double A = *((double *) params);
  //double A = p-> A;
  return (-3/2e0+(A/2e0+1)*x-x*x/2e0)*log((1-x)*(1-x)+A*x);
}

double DT(MassRef & Mass, MmixingRef & Mixing,size_t ih){
  double Mz2=91.2*91.2;
  double Mw2=80.3*80.3;
  double cw2=Mw2/Mz2;
  double sw2=1-cw2;
 
  double result=0e0;  
  for(size_t a=0; a!=Mixing.Nmixed(); ++a){
    result+=pow(Mixing[a][ih],2)*(-Fsimple(pow(Mass[a],2)/Mz2)/cw2-Fsimple(pow(Mass[a],2)/Mw2));
  }

  return result/4e0/acos(-1)/sw2;
}

double DS(MassRef & Mass, MmixingRef & Mixing,size_t ih){
  double Mz2=91.2*91.2;
  double Mw2=80.3*80.3;
  double cw2=Mw2/Mz2;
  double sw2=1-cw2;

  double result=0e0;  
  for(size_t a=0; a!=Mixing.Nmixed(); ++a){
    result+=pow(Mixing[a][ih],2)*PsiTot(pow(Mass[a],2)/Mz2);
  }

  return result/acos(-1);
}

double DU1(MassRef & Mass, MmixingRef & Mixing,size_t ih){
  double Mz2=91.2*91.2;
  double Mw2=80.3*80.3;
  double cw2=Mw2/Mz2;
  double sw2=1-cw2;

  double result=0e0;  
  for(size_t a=0; a!=Mixing.Nmixed(); ++a){
    result+=pow(Mixing[a][ih],2)*PsiTot(pow(Mass[a],2)/Mw2);
  }

  return result/acos(-1);
}

double DTsm(double Mass){
  double Mz2=91.2*91.2;
  double Mw2=80.3*80.3;
  double cw2=Mw2/Mz2;
  double sw2=1-cw2;

  return (-Fsimple(pow(Mass,2)/Mz2)/cw2-Fsimple(pow(Mass,2)/Mw2))/4e0/acos(-1)/sw2;
}

double DSsm(double Mass){
  double Mz2=91.2*91.2;
  double Mw2=80.3*80.3;
  double cw2=Mw2/Mz2;
  double sw2=1-cw2;

  return PsiTot(pow(Mass,2)/Mz2)/acos(-1);
}

double DU1sm(double Mass){
  double Mz2=91.2*91.2;
  double Mw2=80.3*80.3;
  double cw2=Mw2/Mz2;
  double sw2=1-cw2;

  return PsiTot(pow(Mass,2)/Mw2)/acos(-1);
}

double func(double x){
  //cout<<x<< " !!!! "<< x*log(x)/(x-1)<< endl;
  return x*log(x)/(x-1);
}

double gunc(double x){
  return (6-2*x-4*x*x+x*(12-3*x+x*x)*log(x))/12e0/pow(1-x,3);
}
