#include "SuShiWrap.h"

using namespace std;

void CreateInputFileSuShiSM(int pp_ppbar,int order,double CM_energy, double mHiggs){
  ofstream outfile ; // ofstream output file object to write file;
  outfile.open("tempsushi.in"); //open file named "tempsuperiso.lha" in the current directory

  outfile<<"Block SUSHI"<< endl;
  outfile<<"  1   0		# model: 0 = SM, 1 = MSSM, 2 = 2HDM"<<endl;
  outfile<<"  2   0             # 0 = light Higgs (h), 1 = pseudoscalar (A), 2 = heavy Higgs (H)"<< endl;
  outfile<<"  3   " << pp_ppbar<<"		# collider: 0 = p-p, 1 = p-pbar" << endl;
  outfile<<"  4   " << CM_energy<<"  	# center-of-mass energy in GeV" << endl;
  outfile<<"  5   " << order <<"		# order ggh: -1 = off, 0 = LO, 1 = NLO, 2 = NNLO"<< endl;
  outfile<<"  6   " << order << " 	# order bbh: -1 = off, 0 = LO, 1 = NLO, 2 = NNLO"<< endl;
  outfile<<"  7   2 	# electroweak cont. for ggh:"<< endl;
  outfile<<"            # 0 = no, 1 = light quarks at NLO, 2 = SM EW factor"<<endl;
  outfile<<"Block SMINPUTS		# Standard Model inputs"<< endl;
  outfile<<"  1   1.27934000e+02	# alpha_em^(-1)(MZ) SM MSbar"<<endl;
  outfile<<"  2   1.16637000e-05	# G_Fermi"<< endl;
  outfile<<"  3   1.17200000e-01	# alpha_s(MZ) SM MSbar"<< endl;
  outfile<<"  4   9.11876000e+01	# m_Z(pole)"<< endl;
  outfile<<"  5   4.20000000e+00	# m_b(m_b)"<< endl;
  outfile<<"  6   1.73300000e+02	# m_t(pole)"<< endl;
  outfile<<"  8   1.27500000e+00	# m_c(m_c)"<< endl;
  outfile<<"Block MASS"<< endl;
  outfile<<"  25   "<<mHiggs<<"	        # Higgs mass h"<< endl;
  outfile<<"Block DISTRIB"<< endl;
  outfile<<"   1   0		# distribution : 0 = sigma_total, 1 = dsigma/dpt,"<< endl;
  outfile<<" 		        #                2 = dsigma/dy,   3 = d^2sigma/dy/dpt"<< endl;
  outfile<<" 		        #                (values for pt and y: 22 and 32)"<< endl;
   outfile<<"  2   0		# pt-cut: 0 = no, 1 = pt > ptmin, 2 = pt < ptmax,"<< endl;
  outfile<<" 		        #         3 = ptmin < pt < ptmax"<< endl;
  outfile<<"  21   30.d0	# minimal pt-value ptmin in GeV"<< endl;
  outfile<<"  22   100.d0	# maximal pt-value ptmax in GeV"<< endl;
  outfile<<"   3   0		# rapidity-cut: 0 = no, 1 = Abs[y] < ymax,"<< endl;
  outfile<<" 		        #    2 = Abs[y] > ymin, 3 = ymin < Abs[y] < ymax"<< endl;
  outfile<<"  31   0.5d0	# minimal rapidity ymin"<< endl;
  outfile<<"  32   1.5d0	# maximal rapidity ymax"<< endl;
  outfile<<"   4   0		# 0 = rapidity, 1 = pseudorapidity"<< endl;
  outfile<<"Block SCALES"<< endl;
  outfile<<"   1   1d0 	        # renormalization scale muR/mh"<< endl;
  outfile<<"   2   1d0	        # factorization scale muF/mh"<< endl;
  outfile<<"   3   0            # 1 = Use (muR,muF)/Sqrt(mh^2+pt^2) for dsigma/dpt and d^2sigma/dy/dpt"<< endl;
  outfile<<"Block RENORMBOT    # Renormalization of the bottom sector"<< endl;
  outfile<<"   1   0 	        # m_b used for bottom Yukawa:  0 = OS, 1 = MSbar(m_b), 2 = MSbar(muR)"<< endl;
  outfile<<"Block PDFSPEC"<< endl;
  outfile<<"   1   MSTW2008lo68cl.LHgrid		# name of pdf (lo)"<< endl;
   outfile<<"  2   MSTW2008nlo68cl.LHgrid		# name of pdf (nlo)"<< endl;
   outfile<<"  3   MSTW2008nnlo_asmzrange.LHgrid	# name of pdf (nnlo)"<< endl;
  outfile<<"   4   0		# set number"<< endl;
  outfile<<"Block VEGAS"<< endl;
  outfile<<"   1   10000	# number of points"<< endl;
  outfile<<"   2   5		# number of iterations"<< endl;
  outfile<<"   3   0		# print: 0 = no output, 1 = prettyprint, 10 = table"<< endl;
  outfile<<"Block FACTORS"<< endl;
  outfile<<"   1   0.d0	# factor for yukawa-couplings: c"<< endl;
  outfile<<"   2   1.d0	# t"<< endl;
  outfile<<"   3   1.d0	# b"<< endl;

  outfile.close();
  
}

void CreateInputFileSuShi2HDM(int particle,int pp_ppbar,int order,double CM_energy, double mHlight, double mHheavy,double mA,double mHcharged,double alpha,int ModelType){

  if(ModelType>4 || ModelType<1)
    cerr<< "Error in oid CreateInputFileSuperiso2HDM(double mHlight, double mHheavy,double mA,double mHcharged,double alpha,int ModelType): Bad model type!"<< endl;
  /////
  ofstream outfile ; // ofstream output file object to write file;
  outfile.open("tempsushi.in"); //open file named "tempsuperiso.lha" in the current directory

  outfile<<"Block SUSHI"<< endl;
  outfile<<"  1   2		# model: 0 = SM, 1 = MSSM, 2 = 2HDM"<<endl;
  outfile<<"  2  "<< particle <<"         # 0 = light Higgs (h), 1 = pseudoscalar (A), 2 = heavy Higgs (H)"<< endl;
  outfile<<"  3   " << pp_ppbar<<"		# collider: 0 = p-p, 1 = p-pbar" << endl;
  outfile<<"  4   " << CM_energy<<"  	# center-of-mass energy in GeV" << endl;
  outfile<<"  5   " << order <<"		# order ggh: -1 = off, 0 = LO, 1 = NLO, 2 = NNLO"<< endl;
  outfile<<"  6   " << order << " 	# order bbh: -1 = off, 0 = LO, 1 = NLO, 2 = NNLO"<< endl;
  outfile<<"  7   1 	# electroweak cont. for ggh:"<< endl;
  outfile<<"            # 0 = no, 1 = light quarks at NLO, 2 = SM EW factor"<<endl;
  outfile<<"Block 2HDM # 2HDM version according to arxiv:1106.0034"<< endl;
  outfile<<"  2			# (1=I,2=II,3=III,4=IV)"<< endl;
  outfile<<"Block SMINPUTS		# Standard Model inputs"<< endl;
  outfile<<"  1   1.27934000e+02	# alpha_em^(-1)(MZ) SM MSbar"<<endl;
  outfile<<"  2   1.16637000e-05	# G_Fermi"<< endl;
  outfile<<"  3   1.17200000e-01	# alpha_s(MZ) SM MSbar"<< endl;
  outfile<<"  4   9.11876000e+01	# m_Z(pole)"<< endl;
  outfile<<"  5   4.20000000e+00	# m_b(m_b)"<< endl;
  outfile<<"  6   1.73300000e+02	# m_t(pole)"<< endl;
  outfile<<"  8   1.27500000e+00	# m_c(m_c)"<< endl;
  outfile<<"Block MINPAR"<< endl;
  outfile<<"  3   5.d0		        # tanb"<< endl;
  outfile<<"Block ALPHA"<< endl;
  outfile<<"  "<<alpha<<"		# mixing in Higgs sector"<< endl;
  outfile<<"Block MASS"<< endl;
  outfile<<"  25   "<<mHlight<<"	# Higgs mass h"<< endl;
  outfile<<"  35   "<<mHheavy<<"	# Higgs mass H"<< endl;
  outfile<<"  36   "<<mA<<"	# Pseudoscalar Higgs mass A"<< endl;
  outfile<<"Block DISTRIB"<< endl;
  outfile<<"   1   0		# distribution : 0 = sigma_total, 1 = dsigma/dpt,"<< endl;
  outfile<<" 		        #                2 = dsigma/dy,   3 = d^2sigma/dy/dpt"<< endl;
  outfile<<" 		        #                (values for pt and y: 22 and 32)"<< endl;
   outfile<<"  2   0		# pt-cut: 0 = no, 1 = pt > ptmin, 2 = pt < ptmax,"<< endl;
  outfile<<" 		        #         3 = ptmin < pt < ptmax"<< endl;
  outfile<<"  21   30.d0	# minimal pt-value ptmin in GeV"<< endl;
  outfile<<"  22   100.d0	# maximal pt-value ptmax in GeV"<< endl;
  outfile<<"   3   0		# rapidity-cut: 0 = no, 1 = Abs[y] < ymax,"<< endl;
  outfile<<" 		        #    2 = Abs[y] > ymin, 3 = ymin < Abs[y] < ymax"<< endl;
  outfile<<"  31   0.5d0	# minimal rapidity ymin"<< endl;
  outfile<<"  32   1.5d0	# maximal rapidity ymax"<< endl;
  outfile<<"   4   0		# 0 = rapidity, 1 = pseudorapidity"<< endl;
  outfile<<"Block SCALES"<< endl;
  outfile<<"   1   0.5d0 	# renormalization scale muR/mh"<< endl;
  outfile<<"   2   0.5d0	# factorization scale muF/mh"<< endl;
  outfile<<"   3   0            # 1 = Use (muR,muF)/Sqrt(mh^2+pt^2) for dsigma/dpt and d^2sigma/dy/dpt"<< endl;
  outfile<<"Block RENORMBOT    # Renormalization of the bottom sector"<< endl;
  outfile<<"   1   0 	        # m_b used for bottom Yukawa:  0 = OS, 1 = MSbar(m_b), 2 = MSbar(muR)"<< endl;
  outfile<<"   4   4.75d0       # Fixed value of m_b^OS"<< endl;
  outfile<<"Block PDFSPEC"<< endl;
  outfile<<"   1   MSTW2008lo68cl.LHgrid		# name of pdf (lo)"<< endl;
  outfile<<"   2   MSTW2008nlo68cl.LHgrid		# name of pdf (nlo)"<< endl;
  outfile<<"   3   MSTW2008nnlo_asmzrange.LHgrid	# name of pdf (nnlo)"<< endl;
  outfile<<"   4   0		# set number"<< endl;
  outfile<<"Block VEGAS"<< endl;
  outfile<<"   1   10000	# number of points"<< endl;
  outfile<<"   2   5		# number of iterations"<< endl;
  outfile<<"   3   0		# print: 0 = no output, 1 = prettyprint, 10 = table"<< endl;
  outfile<<"Block FACTORS"<< endl;
  outfile<<"   1   0.d0	# factor for yukawa-couplings: c"<< endl;
  outfile<<"   2   1.d0	# t"<< endl;
  outfile<<"   3   1.d0	# b"<< endl;

  outfile.close();
  
}
